https://yujia.io/blog/2015/11/20/SPOJ-COURIER-The-Courier/
Set the base case to be empty set, which mean tasks.
Byteland is a scarcely populated country, and residents of different cities seldom communicate with each other. There is no regular postal service and throughout most of the year a one-man courier establishment suffices to transport all freight. However, on Christmas Day there is somewhat more work for the courier than usual, and since he can only transport one parcel at a time on his bicycle, he finds himself riding back and forth among the cities of Byteland.The courier needs to schedule a route which would allow him to leave his home city, perform the individual orders in arbitrary order (i.e. travel to the city of the sender and transport the parcel to the city of the recipient, carrying no more than one parcel at a time), and finally return home. All roads are bi-directional, but not all cities are connected by roads directly; some pairs of cities may be connected by more than one road. Knowing the lengths of all the roads and the errands to be performed, determine the length of the shortest possible cycling route for the courier.
Specification
Input
The input begins with the integer t, the number of test cases. Then t test cases follow.
Each test case begins with a line containing three integers: n m b, denoting the number of cities in Byteland, the number of roads, and the number of the courier’s home city, respectively (1<=n<=100,1<=b<=m<=10000). The next m lines contain three integers each, the i-th being ui vi di, which means that cities ui and vi are connected by a road of length di (1<=ui,vi<=100, 1<=di<= 10000). The following line contains integer z - the number of transport requests the courier has received (1<=z<=5). After that, z lines with the description of the orders follow. Each consists of three integers, the j-th being uj vj bj, which signifies that bj parcels should be transported (individually) from city uj to city vj. The sum of all bj does not exceed 12.Output
For each test case output a line with a single integer - the length of the shortest possible bicycle route for the courier.
DP Approach
Suppose we are now given only one task. What we need to do is find the shortest path from the home city to the source city. And then find the shortest path from the source city to the destination. Finally, we find the shortest path from the destination to the home. So the first thing we need to do is find the shortest path among all pairs of the cities. There are many algorihms to solve the so called All-pairs shortest paths. The simpliest one is Floyd-Warshall algorithm. Using it will cost time and space. Also we can run Dijsktra algorithm on all vertices. But since the output doesn’t require output the optimal path, so actually we can only store the distance among all pairs of vertices. That’s enough to solve this problem.
After construct the distance matrix. There is a naive way to solve this problem using method of back tracking. Suppose we are given task. There are different choices for us to deliver the first package. We can choose one of them and solve the subproblem. Then we just take the minimum of the result of these choices. That will give us the right answer. It sounds good, but it work pretty bad in time. Since at time , we have choices, and we have choices at each subproblem, we see the time complexity is . Practically, this algorithm won’t work because it’s too “expensive”.
Here is the DP approach. Suppose we are given tasks. And suppose we have already solved all subproblems with tasks from all starting city, . How can we solve the problem with tasks?
For the first task, we have different choices. Since we have already solved the subproblem with task, we just use that result and combine it to get the result of the problem with tasks. Suppose we choose as the first task. Let denote the set of our tasks and denote the optimal solution starting from with task set . Then we have the following relation over :
For the first task, we have different choices. Since we have already solved the subproblem with task, we just use that result and combine it to get the result of the problem with tasks. Suppose we choose as the first task. Let denote the set of our tasks and denote the optimal solution starting from with task set . Then we have the following relation over :
Bit map
Now we have already come up with a DP alogrithm for this problem. What remains is how to implement it. Since the entry in array is integer, how can we let the integer denote our task set? The way to do it is using Bit map. Since each integer is stored as a binary string. We can use , to denote whether the task is in the set or not. For example, suppose now we have different tasks. We have the following different binary string: . means we choose task one and task two. And if we convert them into Decimal, we get . So we just need entries and we can use this map to denote the set of the task.
There are many ways to implement bit map. Here I use the bitwise operator because it’s faster and simpler.
There are many ways to implement bit map. Here I use the bitwise operator because it’s faster and simpler.
//total is the value of 2^t vector<int> trans[total-1]; //Use to store which task we have selected in this entries. (Excluded the empty set) for (int i = 1; i < total; i++){ int temp = i, counter = 0; while (temp){ if (((temp>>1)<<1) != temp) trans[i-1].push_back(counter); counter++; temp = temp >> 1; } }
Efficiency
We have different subproblems. Since the specification says , so it would be at most . For each subproblem, we need to calcualte the result from all cities and each would cost at most time. So the time complexity would be . This is much better than the backtracking method.
Also using the Folyd algorithm will cost time. Then overall running time would be .
Also using the Folyd algorithm will cost time. Then overall running time would be .
Tips
Since here we need to construct a very large table, it’s recommended to store the array in heap instead of stack, or you may get Segmentation fault. By default, the size of array has to be smaller than 1M in C++.
void Floyd(int edge[100][100], int dis[100][100], int size){ for (int i = 0; i < size; i++) dis[i][i] = 0; for (int k = 0; k < size; k++){ for (int i = 0; i < size; i++){ for (int j = 0; j < size; j++){ if (dis[i][k] != -1 && dis[k][j] != -1){ if (dis[i][j] == -1) dis[i][j] = dis[i][k] + dis[k][j]; else if (dis[i][k] + dis[k][j] < dis[i][j]) dis[i][j] = dis[i][k] + dis[k][j]; } } } } } int courier(int edge[100][100], int dis[100][100], int n, int start, vector< pair<int,int> > &task, int** opt){ int tsize = task.size(); int total = 1; for (int i = 0; i < tsize; i++) total = total << 1; for (int i = 0; i < n; i++) opt[0][i] = dis[start][i]; // Use trans to store the tasks in each entries of OPT vector<int> trans[total-1]; for (int i = 1; i < total; i++){ int temp = i, counter = 0; while (temp){ if (((temp>>1)<<1) != temp) trans[i-1].push_back(counter); counter++; temp = temp >> 1; } } // Recursion Relation for (int i = 1; i <= tsize; i++){ // i is the number of task we pick for (int j = 1; j < total; j++){ if (trans[j-1].size() == i){ for (int s = 0; s < n; s++){ int best = 2147483647; for (int k = 0; k < i; k++){ int curtask = trans[j-1][k]; int rest = 1; for (int t = 0; t < curtask; t++) rest = rest << 1; rest = j -rest; int temp = opt[rest][task[curtask].second] + dis[task[curtask].first][s] + dis[task[curtask].first][task[curtask].second]; best = min(best,temp); } opt[j][s] = best; } } } } return opt[total-1][start]; } int main(){ int t; scanf("%d", &t); int **opt; opt = new int*[5000]; for(int i = 0; i < 5000; i++) opt[i] = new int [100]; int edge[100][100]; int dis[100][100]; while(t--){ int n, m, s, z; scanf("%d%d%d", &n, &m, &s); memset(dis, -1, sizeof(int)*100*100); memset(edge, -1, sizeof(int)*100*100); for(int i = 0, u,v,d; i < m; i++){ scanf("%d%d%d", &u, &v, &d); if(edge[u-1][v-1] < d){ edge[u-1][v-1] = edge[v-1][u-1] = d; dis[u-1][v-1] = dis[v-1][u-1] = d; } } Floyd(edge, dis, n); vector< pair<int, int> > task; scanf("%d", &z); for (int i = 0, u,v,b; i < z; i++){ scanf("%d%d%d", &u, &v, &b); while(b--) task.push_back(make_pair(u-1,v-1)); } printf("%d\n", courier(edge, dis, n, s-1, task, opt)); } for(int i = 0; i < 5000; i++) delete opt[i]; delete opt; return 0; }